#include <acknex.h> // include for Pure Mode
#include <default.c> // default key functions

#define maxPlayerRotation 30
#define playerAccel 10
#define playerSmoothSpeed 0.6

// clamps for the plane to not exceed camera sight
// X axis
#define max_xMovement 190
#define min_xMovement -190
// Y axis
#define max_yMovement 150
#define min_yMovement -150

var gameSpeed = 1; // this controls the speed (matrix effects), normal speed is at 1
var inverseControls = -1; // 1 or -1

var cameraSpeed = 10;

var shadow_stencil = 2;// setup stencil shadows

VECTOR playerMovement; // controls player way
VECTOR playerPosition; // stores player positioning
VECTOR playerRotation; // holds player heading

function camera_func();

function main() {
	// initialise vectors
	vec_set(playerMovement, nullvector);
	vec_set(playerPosition, nullvector);
	vec_set(playerRotation, nullvector);
	
	level_load("level_01.wmb");
	wait(5);
	
	camera_func();
}

function camera_func() {
	// create player here
	// currently done in WED <- sucks
	
	while(player) {
		// handle camera activity
		
		// should be replaced with an entity, which moves with c_move
		// then attach the camera to that
		camera.y += (cameraSpeed * gameSpeed) * time_step; // <-- bad temp solution
		
		wait(1);
	}
}

function chopper_act() {
	var tempRot = 0; // bone rotation variable
	player = me;
	
	while(me) {
		// update rotation
		if(!key_space) {
			playerRotation.x = ((key_a - key_d) * maxPlayerRotation) * inverseControls; // heading of # degrees
			tempRot += (playerRotation.x - tempRot) * (playerSmoothSpeed * gameSpeed) * time_step; // update rotation
			
			// reset and rotate bone
			ent_bonereset(my, "rotBone"); // reset a single bone
			ent_bonerotate(my, "rotBone", vector(tempRot, 0, 0)); // rotate bone
		}
		
		playerMovement.x = (key_d - key_a) * (playerAccel * gameSpeed) * time_step; // get movement keys
		playerMovement.y = (key_w - key_s) * (playerAccel * gameSpeed) * time_step;
		
		playerPosition.x += playerMovement.x; // update player position
		playerPosition.y += playerMovement.y;
		
		playerPosition.x = clamp(playerPosition.x, min_xMovement, max_xMovement); // CLAMP player position (relative to camera)
		playerPosition.y = clamp(playerPosition.y, min_yMovement, max_yMovement);
		
		my.x = camera.x + playerPosition.x; // move me WITH the camera
		my.y = camera.y + playerPosition.y;		
		
		c_move(me, playerMovement, nullvector, GLIDE); // move me INSIDE the camera
		
		wait(1);
	}
}